proc start_ping_test {} {
    toplevel .ping_net
    wm title .ping_net "Subnet name entry"

    set quad1 0
    set quad2 0
    set quad3 0

    message .ping_net.subnetping -text "Please enter the subnet you wish to ping:" -width 20c
    entry .ping_net.pingent1 -width 4 -relief sunken -bd 2 -textvariable quad1
    entry .ping_net.pingent2 -width 4 -relief sunken -bd 2 -textvariable quad2
    entry .ping_net.pingent3 -width 4 -relief sunken -bd 2 -textvariable quad3
    button .ping_net.go -text "Start scan" -command "ping_scan"
    button .ping_net.done -text "Exit" -command "destroy .ping_net"

    frame .ping_net.body
    frame .ping_net.footer
    pack .ping_net.body .ping_net.footer -in .ping_net -side top -expand 1

    pack .ping_net.subnetping .ping_net.pingent1 .ping_net.pingent2 .ping_net.pingent3 -in .ping_net.body -side left -expand 1 -padx 2 -pady 2
    pack .ping_net.go .ping_net.done -in .ping_net.footer -side left -expand 1 -padx 2 -pady 2
    raise .ping_net.subnetping
    raise .ping_net.pingent1
    raise .ping_net.pingent2
    raise .ping_net.pingent3
    raise .ping_net.go
    raise .ping_net.done
}


proc ping_scan { } {
    global quad1
    global quad2
    global quad3
    if { $quad1 < 0 } {
	do_ping_error
	return
    }
    if { $quad1 > 255 } {
	do_ping_error
	return
    }
    if { $quad2 < 0 } {
	do_ping_error
	return
    }
    if { $quad2 > 255 } {
	do_ping_error
	return
    }
    if { $quad3 < 0 } {
	do_ping_error
	return
    }
    if { $quad3 > 255 } {
	do_ping_error
	return
    }
    do_ping_scan $quad1 $quad2 $quad3
}

proc do_ping_scan { quad1 quad2 quad3 } {
    set win "${quad1}-${quad2}-${quad3}"
    toplevel .${win}
    wm title .${win} "Subnet scan"
    frame .${win}.header
    frame .${win}.body
    frame .${win}.control
    frame .${win}.footer
    pack .${win}.header .${win}.body .${win}.control .${win}.footer -in .${win} -side top -expand 1
    message .${win}.msg -text "Subnet: ${quad1}.${quad2}.${quad3}" -width 20c
    pack .${win}.msg -in .${win}.header
    button .${win}.update -text "Start Update" -command "update_display $quad1 $quad2 $quad3"
    button .${win}.done -text "Close Subnet" -command "destroy .${win}"
    pack .${win}.update .${win}.done -in .${win}.control -side top -expand 1
    message .${win}.msg1 -text "Welcome to Your Network!" -width 30c
    pack .${win}.msg1 -in .${win}.footer -side top -expand 1
    for { set i 0 } { $i <= 15 } { incr i } {
	frame .${win}.$i
	pack .${win}.$i -in .${win}.body -side left -padx 2 -pady 2
    }
    for { set msb 0 } { $msb <= 15 } { incr msb } {
	for { set lsb 0 } { $lsb <= 15 } { incr lsb } {
	    set host [ expr ${msb} * 16 + ${lsb} ]
	    button .${win}.host${host} -relief raised -text $host -command "get_host_info $quad1 $quad2 $quad3 $host"
	    pack .${win}.host${host} -in .${win}.${lsb} -side top -fill both -expand 1 -padx 1 -pady 1
	    raise .${win}.host${host}
	}
    }
    after 10 [ list update_display $quad1 $quad2 $quad3 ]
}

proc update_display { quad1 quad2 quad3 } {
    set win "${quad1}-${quad2}-${quad3}"
    .${win}.msg configure -fg blue

    update
    if [ expr ! [ file exists /sysadmin/PING.${win} ] ] {
	# Following command Solaris specific.  Please check your man pages.
	system /etc/mknod /sysadmin/PING.${win} p
    }
    eval system /export/home/jberning/perl/uxctl/subnet-scan.pl ${quad1} ${quad2} ${quad3} &
    set FIFO [ open /sysadmin/PING.${quad1}-${quad2}-${quad3} r ]
    while { [ expr ! [ eof $FIFO ] ] } {
	gets $FIFO host_info
	set status [ lindex $host_info 1 ]
	set hostid [ lindex $host_info 0 ]
	if { [ string compare $hostid "" ] != 0 } {
	    if { $status == 0 } {
		catch { .${win}.host${hostid} configure -fg red -activeforeground red } 
	    } else {
		catch { .${win}.host${hostid} configure -fg green -activeforeground green }
	    }
	    update
	}
    }
    update

    .${win}.msg configure -fg black
    update
    after 300000 [ list update_display $quad1 $quad2 $quad3 ]
}

proc do_ping_error { } {
    toplevel .win
    frame .win.frm1
    frame .win.frm2

    label .win.bitmap -bitmap error
    message .win.errortext -text "ERROR: Malformed subnet specification." -width 10c

    button .win.ok -text OK -command "destroy .win"

    pack .win.frm1 .win.frm2 -in .win -side top -expand 1 -padx 2 -pady 2
    pack .win.bitmap .win.errortext -in .win.frm1 -side left -expand 1
    pack .win.ok -in .win.frm2 -side top -expand 1

    raise .win.bitmap
    raise .win.errortext
    raise .win.ok

    tkwait visibility .win.ok
    grab set -global .win.ok
}



proc get_host_info { quad1 quad2 quad3 quad4 } {
    set host "${quad1}-${quad2}-${quad3}-${quad4}-hinfo"
    toplevel .${host}
    wm title .$host "Host query"
    set host_ip_addr "${quad1}.${quad2}.${quad3}.${quad4}"
    set host_fqdn [ exec /export/home/jberning/perl/uxctl/get-fqdn.pl $host_ip_addr ]
    if [ expr [ string compare $host_fqdn "NOHOST" ] == 0 ] {
	set host_short_name "NOHOST"
	set host_domain_name "NODOMAIN"
    } else {
	set host_short_name [ lindex [ split $host_fqdn "." ] 0 ]
	set host_domain_name [ join [ lrange [ split $host_fqdn "." ] 1 end ] "." ]
    }
    button .${host}.ok -text "OK" -command "destroy .${host}"
    frame .${host}.body
    frame .${host}.footer
    pack .${host}.body .${host}.footer -in .${host} -expand 1 -padx 1 -pady 1
    message .${host}.ipinfo -text "Host IP address: ${host_ip_addr}" -width 20c
    message .${host}.fqdn -text "Fully qualified domain name: ${host_fqdn}" -width 30c
    message .${host}.sname -text "Short name alias: ${host_short_name}" -width 20c
    message .${host}.domain -text "Home domain: [ string toupper ${host_domain_name} ]" -width 20c

    pack .${host}.ipinfo .${host}.fqdn .${host}.sname .${host}.domain -in .${host}.body -side top -expand 1 -fill both -padx 1 -pady 1

    pack .${host}.ok -in .${host}.footer -side top -expand 1
    raise .${host}.ok

}
